# <20170328.1154.04>


# These should use the "quick" option, I think...
proc CmdToright {} {
  global glob
  NewPwd right $glob(left,pwd)
  UpdateWindow_ right 1
}

proc CmdToleft {} {
  global glob
  NewPwd left $glob(right,pwd)
  UpdateWindow_ left 1
}

proc CmdSwapWindows {} {
  global glob
  set tmpright $glob(left,pwd)
  set glob(forceupdate) 1
  CmdToleft
  NewPwd right $tmpright
  UpdateWindow right
  set glob(forceupdate) 0
}

proc BatchReceiveFTP { inst } {
  global glob
  if {[IsFTP $glob($inst,pwd)]} {
    PopInfo [_ "You can only issue a receive request to a non-FTP directory"]
    return
  }
  set olddir $glob([Opposite $inst],pwd)
  foreach itemblock $glob(batchlist) {
    set item [lindex $itemblock 0]
    set r [regexp {ftp://([^/]*)(.*)} $item match ftpI elem]
    if {!$r} {
      PopWarn [_ "Can't parse %s as FTP file" $item]
    } else {
      NewPwd [Opposite $inst] ftp://$ftpI/
      set r [Try { FTP_GetFile $ftpI "$elem" \
		       "$glob($inst,pwd)/[file tail $elem]" \
		       [lindex $itemblock 1] 0 } "" 1]
    }
  }
  set glob(batchlist) {}
  set glob(forceupdate) 1
  NewPwd [Opposite $inst] $olddir
  UpdateWindow both
  set glob(forceupdate) 0
}

proc SandDsame {} {
    smart_dialog .apop . [_ "Oops That doesn't work"] \
	[list [_ "Please set different source and destination directories!"]]\
	0 1 [_ "OK"] 
}

proc CmdCopy {{resume 0} {cmd cp}} {
  global glob
  if { $glob(left,pwd) == $glob(right,pwd) } {
    SandDsame
    return {}
  }    
  CmdCopy_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left $resume $cmd
  CmdCopy_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right $resume $cmd
  UpdateWindow both
  set glob(forceupdate) 0
}
proc CmdHardlnk {{resume 0}} {
  CmdCopy $resume hardlink
}

proc CmdCopy_ { listb_name filelist_var frompwd topwd inst resume option} {
  # For speed, (hopefully) we'll call by reference...
  # option should be cp or hardlink and indicates what config entry to use
  # i.e. config(cmd,$option)
  global config glob
  upvar $filelist_var filelist
	    frputs glob(async)
  set oinst [Opposite $inst]
  if {$option == "hardlink"} {
    foreach sd {source destionation} dir {$frompwd $topwd} {
      if {[IsFTP $dir] } {
	Log [_ "IsFTP $sd and options %s" $option]
	CantDoThat
	return
      }
    }
    set op "Hardlinking"
  } else {
    set op "cp"
  }
  # get this nonsense out of the way once
  if {[IsFTP $topwd] && [IsFTP $frompwd]} {
    Log [_ "IsFTP source and destination"]
    CantDoThat
    return
  }
# Copy and copyas copy links, not what they point at
  set selList [$listb_name curselection]
  # This keeps track of global yes/no from the ok to delete query
  # 2 global yes
  # 3 global no
  # Other vaues -> unknown
  set glbYN 0
  set dglbYN 0
  foreach sel $selList {
    if {[CheckAbort [_ "Copy"]]} {return}
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    set ff [lindex $elem 1]
    # Check if we are bing asked to overwite...
    set target [lsearch -exact -index 1 -inline $glob($oinst,filelist) $ff]
    set ffile $frompwd/$ff
    set tof $topwd/$ff
    set ford [switch $swt {
      d -     
      fd {if {$config(ask,dir_delete)} {expr {{directory tree}}}} 
      default {if {$config(ask,file_delete)} {expr {{file}}}}
    }]
    set dT [expr {$ford != "file" ? {d} : {} }]

    if {$target != {}} {
      switch -exact [set ${dT}glbYN] {
	3  {continue}
	0 -
	1 {set ${dT}glbYN [deleteQuery $ford $tof [llength $selList]]}
      }
      if {[set ${dT}glbYN] == 1 || [set ${dT}glbYN] == 3} {continue}
    }

    Log [_ "%s switching on %s" CmdCopy_ [lindex $elem 2]]
    switch $swt {
      fld -
      fd  { 
        set olddir $glob($inst,pwd)
        set r [Try {CopyFromFTPRecursive "$ffile" "$topwd" $inst $resume } "" 1]
        NewPwd $inst $olddir
        UpdateWindow $inst
    }
      fl  -
      fn  {
        if {[IsFTP $frompwd]} { 
          set size [lindex $elem 3]
          if {[lindex $elem 2] == "fl"} {set size -1}
	  frECF [list FTP_GetFile] \
	      [list $ftpI\
		   $directory/[lindex $elem 1]\
		   $tof \
		   $size \
		   $resume ]\
	      [list -default { "%n"}\
		   -back $glob(async)]
        }
      }
      n -
      wl -
      l   {
        Log [_ "%s (1) %s >> %s"  "$op" "$ffile" "$topwd"]

	if {[IsFTP $topwd]} {
          set glob(forceupdate) 1
          Try {FTP_PutFile $ftpI $ffile \
		    $directory/[lindex $elem 1] [lindex $elem 3] } "" 1
        } elseif {[CheckWhoOwns $tof overwrite]} {

	  # This is the file copy or hardlink
	  # configure the command...
	  set cpcmd $config(cmd,$option)
	  set to $topwd
	  if {$cpcmd == {}} {
	    if {$option == "cp"} {
	      set cpcmd "file copy -force"
	    } else {
	      set cpcmd "file link -hard %2@s"
	      set to $tof
	    }
	  } else {
	    set cpcmd [list exec {*}[subst {*}$::stOps $cpcmd]]
	    if {$glob(async)} {
	      append cpcmd " %b &"
	    }
	  }
	  frputs "pre frECF:  " ffile topwd
	  frECF [list {*}$cpcmd]\
	      [list $ffile $to] [list -b $glob(async)]
	    
	}
      }

      d   -
      wld -
      ld   { 
       if {[IsFTP $topwd]} {
          set olddir $glob($inst,pwd)
          set r [Try { CopyToFTPRecursive $ffile $topwd $inst } "" 1]
          NewPwd $inst $olddir
          set glob(forceupdate) 1
	  UpdateWindow $inst
	  set glob(forceupdate) 0
        } else {
	  # This is the dir copy
	  Log [_ "%s (d) %s >> %s" $op $ffile $topwd]
	  
	  if {[CheckWhoOwns $tof overwrite]} {
	    set cpcmd $config(cmd,$option)
	    if {$option == "cp"} {
	      lassign $config(cmd,dircp) cpcmd dirFlag
	      
	      # Most (all?) of the copy commands in windows blightly assume
	      # that you really ment to put "\*" on the end of source directory
	      # If the user would really like to back that assumption out
	      # we allow him to code an option in the config(cmd,dircp)
	      # (second entry in the list) to tell us what s/he really
	      # wants. To work this wonder we just add the final dir in
	      # the source to the destination...
	      
	      if {[string match {*-\**} $dirFlag]} {
		set topwd $tof
	      } else {
		# oops! that must be part of the command
		set cpcmd $config(cmd,dircp)
	      }
	    }
	    if {$cpcmd == {}} {
	      if {$option == "cp"} {
		set cpcmd "file copy -force"
	      } else {		
		set cpcmd  "recHardLink %b -L"
	      }
	      if {$ffile == $topwd} {
		PopError [_ "Can't %s recursively into same directory (%s -> %s)"\
			    $op $ffile $topwd]
		return
	      }
	    } else {
	      set cpcmd [list exec {*}[subst {*}$::stOps $cpcmd]]
	      if {$glob(async)} {
		append cpcmd " %b &"
	      }
	    }
	    frECF [list {*}$cpcmd]\
		[list $ffile $topwd] [list -b $glob(async)]
	  }
        }
      }
      default {
	  Log [_  "file type %s ??" [lindex $elem 2]]
	  CantDoThat
      }
    }
  }
}

proc CmdCopyAs {} {
  global glob
  CmdCopyAs_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd)
  CmdCopyAs_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdCopyAs_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  set selList [$listb_name curselection]
  # This keeps track of global yes/no from the ok to delete query
  # 2 global yes
  # 3 global no
  # Other vaues -> unknown
  set glbYN 0
  set dglbYN 0
  foreach sel $selList {
    if {[CheckAbort [_  "CopyAs"]]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    set ffile $frompwd/[lindex $elem 1]
    set ford [switch $swt {
      d -     
      fd {if {$config(ask,dir_delete)} {expr {{directory tree}}}} 
      default {if {$config(ask,file_delete)} {expr {{file}}}}
    }]
    set dT [expr {$ford != "file" ? {d} : {} }]

    switch $swt {
      fl -
      fn -
      l  -
      n  {set query [_ "destination file"]
      }
      d  -
      wld -
      ld {set query [_ "directory after copy"]
      }
      default {
	CantDoThat
	return
      }
    }
    set destfile [simple_smart_dialog "." [_  "Copy As..."] \
		      [_  "Please enter new name for %s" $query] \
		      $topwd/[lindex $elem 1]]
    if {$destfile == "" } {return}

    if {[IsFTP $destfile]} {
      CantDoThat
      return
    }
    # overwrite testing is a bit messy as the target may not
    # be in one of the given dirs... However since we don't allow
    # FTP targets, we can do a "file" command...
    if {[file exists $destfile]} {
      switch -exact [set ${dT}glbYN] {
	3  {continue}
	0 -
	1 {set ${dT}glbYN [deleteQuery $ford $destfile [llength $selList]]}
      }
      if {[set ${dT}glbYN] == 1 || [set ${dT}glbYN] == 3} {continue}
    }
    switch $swt {
      fl  -
      fn  {
	if {![IsFTP $frompwd]} { 
	  PopError [_ "Can't parse %s as ftp URL" $frompwd] 
	} else {
	  set size [lindex $elem 3]
	  if {[lindex $elem 2] == "fl"} {set size -1}

	  frECF [list FTP_GetFile %n %n $size 0] \
	      [list  $directory/[lindex $elem 1] $destfile]\
	      [list -default { "%n"}\
		   -back $glob(async)]
	}
      }
      n  -
      wl -
      l   { 
	Log [_ "Copying %s >> %s" \
		 "$config(cmd,cp) $frompwd/[lindex $elem 1]" $destfile]
	if {$config(cmd,cp) == {}} {
	  set cmd "file copy"
	} else {
	  set cmd "exec [subst {*}$::stOps $config(cmd,cp)]"
	  if {$glob(async)} {
	    append cmd " %b &"
	  }
	}

	frECF [list {*}$cmd] \
	    [list $ffile $destfile] -back $glob(async)
	
      }
      d   -
      wld -
      ld  { 
	Log [_  "Copying %s to %s" \
		 "$config(cmd,dircp) $frompwd/[lindex $elem 1]" $destfile]
	# Don't get confused by the -\ option...
	lassign $config(cmd,dircp) cpcmd dirFlag
	if {![string match {*-\**} $dirFlag]} {
	  set cpcmd $config(cmd,dircp)
	}
	if {$cpcmd == {} } {
	  set cmd "file copy -force"
	  if {$ffile == $topwd} {
	    PopError [_ "Can't copy recursively into same directory (%s -> %s)"\
			  $ffile $topwd]
	    return
	  }
	} else {
	  set cmd "exec [subst {*}$::stOps $cpcmd]"
	  if {$glob(async)} {
	    append cmd " %b &"
	  }
	}
	frECF [list {*}$cmd]\
	    [list $ffile $destfile]\
	    -back $glob(async) -back $glob(async)
	
      }
      default CantDoThat
    }
  }
}

proc SoftLink { src dst } {
  global config
  if {$config(create_relative_links)} {
    set srcdir [file dirname $src]
    set dstdir [file dirname $dst]
    set srcfile [file tail $src]
    set dstfile [file tail $dst]
    set dstlist [split $dstdir /]
    set srclist [split $srcdir /]
    set dstlen [llength $dstlist]
    set srclen [llength $srclist]
    # Count how many directories are the same in the source and destination paths
    set index 0
    while {([lindex $srclist $index] == [lindex $dstlist $index]) && \
	       ($index < $srclen) && ($index < $dstlen)} {
      incr index
    }
    # Build relative link
    set link {}
    for {set dstindex $index} {$dstindex < $dstlen} {incr dstindex} {
      append link ../
    }
    for {set srcindex $index} {$srcindex < $srclen} {incr srcindex} {
      append link [lindex $srclist $srcindex]/
    }
    set from $link$srcfile
    cd $dstdir
    Log [_ "%s : file -s %s" \
	     "$src $dst $srcdir $srcfile $dstdir $dstfile" "$dst $from"]
    if {[Try {file link -symbolic $dst $from} "" 0] == 1 } {
       Try {file link  $dst $from} "" 1
    }
   
  } else {
    Try {file link -symbolic $dst $src} "" 1
  }
}

proc CmdSoftLink {} {
  global glob
  if { $glob(left,pwd) == $glob(right,pwd) } {
    SandDsame
    return {}
  }    
  if {[IsFTP $glob(left,pwd)] || [IsFTP $glob(right,pwd)]} {
    # Well, with FTP we actually can, but we need them both to be
    # on the same remote 
    set l [regexp {([a-z]?)ftp://([^/]*)(.*)} $glob(left,pwd) \
	       match lsftp lftpI ldirectory]
    set r [regexp {([a-z]?)ftp://([^/]*)(.*)} $glob(right,pwd) \
	       match rsftp rftpI rdirectory]
    if {$l && $r && $rftpI == $lftpI} {
      # missing code here...
      # It is OK, it is handled below..
    } else {
      frputs "softlink " l r rftpI lftpI  glob(left,pwd) glob(right,pwd)
      CantDoThat
      return
    }
  }
  CmdSoftLink_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd)
  CmdSoftLink_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdSoftLink_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "SoftLink"]]} return
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      n   -
      d   -
      l   -
      wl  -
      wld -
      ld  { 
        Log [_ "Softlinking %s to %s" "$frompwd/[lindex $elem 1]" $topwd]
        SoftLink $frompwd/[lindex $elem 1] $topwd/[lindex $elem 1]
      }
      fn -
      fd -
      fl -
      fld {
       Log [_ "Softlinking %s to %s" "$frompwd/[lindex $elem 1]" $topwd]
	regexp {ftp://([^/]*)(.*)} $frompwd match ftpI directory
	regexp {ftp://([^/]*)(.*)} $topwd match ftpI tdirectory
	Try {FTP_LinkFile $ftpI \
		 "$directory/[lindex $elem 1]" \
		 "$tdirectory/[lindex $elem 1]"} "" 1
	set glob(forceupdate) 1
      }
      default {
	CantDoThat
	return
      }
    }
  }
}

proc CmdSoftLinkAs {} {
  global glob
  CmdSoftLinkAs_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd)
  CmdSoftLinkAs_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdSoftLinkAs_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "SoftLinkAs"]]} return
    set elem [lindex $filelist $sel]
    set destfile [simple_smart_dialog "." [_ "Soft-Link As..."] \
		      [_ "Please enter new name for destination link"] \
		      $topwd/[lindex $elem 1] ]
    if {[IsFTP $frompwd] || [IsFTP $destfile]} {
      # Well, with SFTP we actually can, but we need them both to be
      # on the same remote & SFTP (but I said that)
      set l [regexp {([a-z]?)ftp://([^/]*)(.*)} $frompwd \
		 match lsftp lftpI ldirectory]
      set r [regexp {([a-z]?)ftp://([^/]*)(.*)} $destfile \
		 match rsftp rftpI rdirectory]
 #     puts "$l && $r && $rftpI == $lftpI && $lsftp $ldirectory $rdirectory"
      if {$l && $r && ($rftpI == $lftpI) } {
      } else {
	CantDoThat
	return
      }
    }
    if {$destfile != "" } {
      Log [_ "Softlinking %s to %s" "$frompwd/[lindex $elem 1]" $destfile]
      switch [lindex $elem 2] {
	n   -
	d   -
	l   -
	wl  -
	wld -
	ld  {
          SoftLink $frompwd/[lindex $elem 1] $destfile
        }
	fn -
	fd -
	fl -
	fld {
	  Log [_ "Softlinking %s to %s" "$frompwd/[lindex $elem 1]" $destfile]
	  Try {FTP_LinkFile $rftpI \
		   "$ldirectory/[lindex $elem 1]" \
		   "$rdirectory"} "" 1
	  set glob(forceupdate) 1
	}
	default {CantDoThat}
      }
    }
  }
}


proc CmdMove {} {
  global glob
  if { $glob(left,pwd) == $glob(right,pwd) } {
    SandDsame
    return {}
  }    
#  if {[IsFTP $glob(left,pwd)] || [IsFTP $glob(right,pwd)]} {
#    FTP_Move
#    return
#  }
  CmdMove_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd)
  CmdMove_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdMove_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist
  set selList [$listb_name curselection]
  # This keeps track of global yes/no from the ok to delete query
  # 2 global yes
  # 3 global no
  # Other vaues -> unknown
  set glbYN 0
  foreach sel  $selList {
    if {[CheckAbort [_ "Move"]]} return
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      d   -
      l   -
      wl  -
      ld  -
      wld -
      n   { 
	set tof $topwd/[lindex $elem 1]
        if {[CheckWhoOwns $frompwd/[lindex $elem 1] move] && \
		[CheckWhoOwns $tof overwrite]} {
	  # We can't overwrite a dir, so don't check that.
	  if {[file isfile $tof]} {
	    switch -exact $glbYN {
	      3  {continue}
	      0 -
	      1 {
		if {$config(ask,file_delete)} {
		  set glbYN [deleteQuery "file" $tof [llength $selList]]
		}
	      }
	    }
	    if {$glbYN == 1 || $glbYN == 3} {continue}
	  }
	}
	Log [_ "Moving %s to %s" $frompwd/[lindex $elem 1] $topwd]
	Try { file rename -force -- \
		  $frompwd/[lindex $elem 1] $topwd } "" 1 $glob(async)
      }
      fn  -
      fld -
      fl  -
      fd {
	set rf [regexp {ftp://([^/]*)(.*)} \
		    $frompwd/[lindex $elem 1] match ftpIf ffile]
	set rt [regexp {ftp://([^/]*)(.*)} \
		    $topwd/[lindex $elem 1] match ftpIt tfile]
	if {$rf == 1 && $rt == 1 && $ftpIf == $ftpIt } {
	  Try { FTP_Rename $ftpIf $ffile $tfile } "" 1
	  set glob(forceupdate) 1	  
	} else {
	  # to or from either different ftp locations or ftp & local file
	  # do a copy followed by a delete
	  # maybe later...
          CantDoThat
          return
	}  
      }
	
      default CantDoThat
    }
  }
}

proc CmdDelete {} {
  global glob
  CmdDelete_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd) left
  CmdDelete_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd) right
  UpdateWindow both
  set glob(forceupdate) 0
}

proc deleteQuery {ford elem num} {
  if {$ford == ""} {return 0}
  return [smart_dialog .apop . [_ "Sure?"] \
	      [list [_ "OK to delete %s ?" \
			 "$ford $elem"]]\
	      0 [expr {$num > 1 ? 4 : 2}] \
	      [list [_ "Yes"] [_ "No"] [_ "Yes to All"] [_ "No toAll"]]]
}

proc CmdDelete_ { listb_name filelist_var frompwd topwd inst } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  set selList [$listb_name curselection]
  # This keeps track of global yes/no from the ok to delete query
  # 2 global yes
  # 3 global no
  # Other vaues -> unknown (0 yes, 1 no)
  # we ask seperatly for files and dirs.
  set dglbYN 0
  set glbYN 0
  foreach sel $selList {
    if {[CheckAbort [_ "Delete"]]} return
    set elem [lindex $filelist $sel]
    set type [lindex $elem 2]
    set ford [switch $type {
      d -     
      fd {if {$config(ask,dir_delete)} {expr {{directory tree}}}} 
      default {if {$config(ask,file_delete)} {expr {{file}}}}
    }]
    set dT [expr {$ford != "file" ? {d} :{}}]

    set ff $frompwd/[lindex $elem 1]
    switch -exact [set ${dT}glbYN] {
      3  {continue}
      0 -
      1 {set ${dT}glbYN [deleteQuery $ford $ff [llength $selList]]}
    }
    if {[set ${dT}glbYN] == 1 || [set ${dT}glbYN] == 3} {continue}

    switch $type {
      l   -
      wl  -
      ld  -
      wld -
      n   -
      d { 
	if {[CheckWhoOwns $ff delete]} {
	  if {$config(cmd,rm) == {}} {
	    Log [_ "Deleting %s" $ff]
	    Try { file delete -force -- $ff } "" 1
	  } else {
	    Log [_ "Using \"%s\" to delete %s" $config(cmd,rm) $ff ]
	    Try {exec {*}$config(cmd,rm) $ff}  {} 1
	  }
	}
      }
      fn  -
      fld -
      fl  {
	Log [_ "Deleting %s" $ff]
	set r [regexp {ftp://([^/]*)(.*)} $ff match ftpI file]
	if {$r} {
	  set glob(forceupdate) 1
	  Try { FTP_Delete $ftpI "$file" } "" 1
	}
      }
      fd  {
	Log [_ "Deleting %s" $ff]
	set glob(forceupdate) 1
	Try { DeleteFTPRecursive "$ff" $inst } "" 1
      }
      default CantDoThat
    }
  }
}
# This command is nearly the same as View  It uses the windows
# file 'assoc' and 'ftype' functions to figure out how
# to 'open' a file.  (We use 'open' as windows means it.)


proc CmdOpen {} {
#  puts "CmdWinOpen"
  global glob
  CmdView_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left open
  CmdView_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right open
}

# This command allows the help file to be compressed, .gz now, .zip someday.

proc ViewHelp {seed} {
  frputs "ViewHelp  " seed
  if {[file exists $seed]} {
    ViewText $seed
  } elseif {[file exists $seed.gz]} {
    ViewText $seed.gz
  } else {
    PopError "Can't find $seed"
  }
}

proc CmdView {} {
#  puts "CmdView"
  global glob
  CmdView_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left
  CmdView_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right
}

proc CmdView_ { listb_name filelist_var frompwd topwd inst {extList view}} {
  # For speed, (hopefully) we'll call by reference...
#  puts "CmdView_"
  global glob config env
  upvar $filelist_var filelist
  set filenamelist {}
  set filenameorg {}
  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "View"]]} return
    set fileelem [lindex $filelist $sel]
    set file1 $frompwd/[lindex $fileelem 1]
    # for windows lnk files we pass both the translated version and the file
    switch [lindex $fileelem 2] {
      l   -
      n   { 
	lappend filenamelist $file1
	lappend filenameorg  $file1
      }
      wl  { 
	lappend filenamelist [TranslateLnk [wLinkName $inst $fileelem] \
				      [lindex $glob($inst,df) 1]]
	lappend filenameorg $file1
      }
      wld {
	set newdir [TranslateLnk [wLinkName $inst $fileelem] \
			[lindex $glob($inst,df) 1]]
	if {$newdir != {}} {
	  NewPwd $inst $newdir
	  UpdateWindow $inst
	}
      }
      fd  -
      fld -
      ld  - 
      d   { NewPwd $inst $glob($inst,pwd)/[lindex $fileelem 1]
	         UpdateWindow $inst
	         return
          }
      fn  -
      fl  { 
	set file [MoveToTmp $fileelem $inst]
	lappend filenamelist $file
	lappend filenameorg  $file
      }
      default CantDoThat
    }
  }
  if {$filenamelist != {}} {
    ViewAny $filenamelist $extList $filenameorg
  }
}

proc MoveToTmp { fileelem inst } {
  global glob
  set r [regexp {ftp://([^/]*)(.*)} \
	     $glob($inst,pwd) match ftpI directory]
  if {$r == 0} { 
    PopError [_ "Can't parse %s as ftp URL" $glob($inst,pwd)]
    return {}
  } else { 
    set r 0
    if { ! [file exists $glob(tmpdir)] } {
      set r [Try { file mkdir $glob(tmpdir) } "" 1]
    }
    if { !$r } {
      set size [lindex $fileelem 3]
      if {[lindex $fileelem 2] == "fl"} {set size -1}
      set r [Try { 
	FTP_GetFile $ftpI "$directory/[lindex $fileelem 1]" \
	    "$glob(tmpdir)/[lindex $fileelem 1]"\
	    $size 0 } "" 1]
      if {$r == 0} {
	set glob(havedoneftp) 1 
	#	                  puts "$glob(tmpdir)/[lindex $fileelem 1]"
	#return [regsub -all {\ }\
	#	    "$glob(tmpdir)/[lindex $fileelem 1]" {\\ }]
	return $glob(tmpdir)/[lindex $fileelem 1]
      }
    }
  }
}


proc CmdViewAsText {} {
  global glob
  CmdViewAsText_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdViewAsText_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdViewAsText_ { listb_name filelist_var frompwd topwd } {
  global glob
  # For speed, (hopefully) we'll call by reference...
  upvar $filelist_var filelist
  set inst $glob(select_cur_lr)
  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      wl  { ViewText [TranslateLnk [wLinkName $inst $elem] \
		      [lindex $glob($inst,df) 1]]
      }
      l   -
      n   { ViewText $frompwd/[lindex $elem 1] }
      ld  -
      wld -
      d   { PopInfo [_ "Can't view directory %s in the text viewer" \
			 "$frompwd/[lindex $elem 1]"] }
      fn  -
      fl  { ViewText [MoveToTmp $elem $inst]}
      default CantDoThat
    }
  }
}

proc CmdCheckSize {} {
  global glob
  CmdCheckSize_ $glob(listbox,left).file glob(left,filelist)\
      $glob(left,pwd) $glob(right,pwd) left
  CmdCheckSize_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right
}

proc CmdCheckSize_ { listb_name filelist_var frompwd topwd inst } {
  # For speed, (hopefully) we'll call by reference...
  global glob config env
  upvar $filelist_var filelist
  set filenamelist {}
  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "View"]]} return
    set fileelem [lindex $filelist $sel]
    switch [lindex $fileelem 2] {
      d   -
      ld  -
      wld -
      wl  -
      l   -
      n   { lappend filenamelist $frompwd/[lindex $fileelem 1] }
      default CantDoThat
    }
  }
  if {$filenamelist != {}} {
    set pr [lindex $config(cmd,du) 0]
    frECF [list exec {*}[subst {*}$::stOps $config(cmd,du)]] $filenamelist \
	     [list -post \
		  [list postOptions [list ViewString [_ "Output from %s" $pr]] nop ]]
   }
}

proc CmdWhatIs {} {
  global glob
  CmdWhatIs_ $glob(listbox,left).file glob(left,filelist)\
      $glob(left,pwd) $glob(right,pwd)
  CmdWhatIs_ $glob(listbox,right).file glob(right,filelist)\
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdWhatIs_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  upvar $filelist_var filelist
  set filenamelist {}
  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      l   -
      wl  -
      wld -
      n   -
      ld  -
      d   {
	frECF [list exec file ] [list $frompwd/[lindex $elem 1]]
          }
      default CantDoThat
    }
  }
}
	# Try { PopInfo [exec file "$frompwd/[lindex $elem 1]"] } "" 1 

proc CmdEdit {} {
  global glob
  CmdEdit_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdEdit_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdEdit_ { listb_name filelist_var frompwd topwd } {
  global env config glob
  # For speed, (hopefully) we'll call by reference...
  upvar $filelist_var filelist
  set filenamelist {}
  set inst $glob(select_cur_lr)

  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    switch  $swt {
      l   -
      wl  -
      n   { lappend filenamelist  $ffile }
      ld  -
      wld -
      d   { PopInfo [_ "Can't edit directory %s in the text editor" "$ffile"] }
      default CantDoThat
    }
  }
  if {$filenamelist != {}} {
    Log "exec $config(editor) $filenamelist"

    set rr [frECF [list exec {*}[subst {*}$::stOps $config(editor)]] $filenamelist]
  }
}

proc CmdQEdit {} {
  global glob
  CmdQEdit_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdQEdit_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdQEdit_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global glob
  upvar $filelist_var filelist
  set inst $glob(select_cur_lr)

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Q-Edit"]]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    switch $swt {
      wl  -
      l   -
      n   { 
            set r [Try {EditText "$ffile" ""} \
		       [_ "Error editing %s" $ffile] 1]
            if {$r != 0} { catch { destroy .toplevel_$glob(toplevelidx) } }
          }
      ld  -
      d   { PopInfo [_ "Can't edit directory %s in the text editor" "$ffile"] }
      default CantDoThat
    }
  }
}


proc CmdRename {} {
  global glob
  CmdRename_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdRename_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
  set glob(forceupdate) 0
}

proc CmdRename_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Rename"]]} return
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      d   -
      wl  -
      l   -
      wld -
      ld  -
      n   { 
        if {[CheckWhoOwns $frompwd/[lindex $elem 1] rename]} {
          set newname [simple_smart_dialog "." \
			   [_ "Rename"] \
			   [_ "Please enter new name."] \
			   $frompwd/[lindex $elem 1] ]
          if {$newname != ""} {
            if {[CheckWhoOwns $newname overwrite]} {
              Log [_ "Renaming %s to %s" $frompwd/[lindex $elem 1] $newname]
              Try { file rename -force -- $frompwd/[lindex $elem 1] $newname }\
		  "" 1
            }
          }
        }
      }
      fl  -
      fld -
      fd  -
      fn  {
        set newname [simple_smart_dialog "." [_ "Rename"] \
			 [_ "Please enter new name."] \
			 $frompwd/[lindex $elem 1]]
        if {$newname != ""} {
          Log [_ "Renaming %s to %s" "$frompwd/[lindex $elem 1]" $newname]
          set r [regexp {ftp://([^/]*)(.*)} $frompwd/[lindex $elem 1]\
		     match ftpI oldftpname]
          if {!$r} {
            PopError [_ "Error in URL %s" $frompwd/[lindex $elem 1]]
          } else {
            set r [regexp {ftp://([^/]*)(.*)} $newname match ftpI newftpname]
            if {!$r} {
              PopError [_ "Error in URL %s" $newname]
            } else {
              Try { FTP_Rename $ftpI $oldftpname $newftpname } "" 1
              set glob(forceupdate) 1
            }
          }
        }
      }
      default CantDoThat
    }
  }
}


proc CmdUnArc {} {
  CmdUnArcPack unarc
}
proc CmdUnPack {} {
  CmdUnArcPack unpack
}

proc CmdUnArcPack {which} {
  global glob
  CmdUnArcPack_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) $which
  CmdUnArcPack_ $glob(listbox,right).file glob(right,filelist)\
      $glob(right,pwd) $glob(left,pwd) $which
  UpdateWindow both
}

proc CmdUnArcPack_ { listb_name filelist_var frompwd topwd which} {
  upvar $filelist_var filelist
  global glob
  set inst $glob(select_cur_lr)
  foreach sel [$listb_name curselection] {
    if {[CheckAbort $which]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    switch $swt {
      ld  -
      wld -
      d   { PopError [_ "Can't %s directory %s..." $which [lindex $elem 1]] }
      l   -
      wl  -
      n   { Log [_ "Which %s to %s" $ffile $topwd]
            UnArcPackAny $ffile $topwd $which
          }
      default CantDoThat
    }
  }
}


proc CmdArc {} {
  global glob
  CmdArc_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdArc_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdArc_ { listb_name filelist_var frompwd topwd } {
  global config glob
  upvar $filelist_var filelist
  set inst $glob(select_cur_lr)

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Archive"]]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
	set ffile [file join $frompwd $ffile]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    set tail [file tail $ffile]
    set dir [file dirname $ffile]
    switch $swt {
      wl  -
      l   -
      n   { 
        Log [_ "Packing %s" $ffile]
#        Try { eval exec [format $config(cmd,pack) \
	    #	    {$ffile}] } "" 1  $glob(async)
	set rr [frECF [list exec {*}[subst {*}$::stOps $config(cmd,pack)]] \
			 [list $ffile] \
			 [list -b $glob(async)]]
	lassign $rr r out
	if {$r != 0} {
	  PopError $out
	}
        # Try { eval eval exec [format $config(cmd,pack) [Esc $ffile]] }\
	#     "" 1  $glob(async)
      }
      wld -
      ld  -
      d   { 
        Log [_ "Archiving %s" $ffile]
	cd $dir
        if {$config(cmd,archive) == "tar+gz {%s}"} {
	  frECF [list exec tar cf - %a | gzip > %a] \
	      [list $tail $tail.tar.gz] \
	      [list -back $glob(async)]
	  
          # Try { cd $dir; exec tar cf - $tail | \
	  # 	    gzip > $tail.tar.gz } "" 1 $glob(async)
        } else {
	  frECF [list exec {*}[subst {*}$::stOps $config(cmd,archive)]]\
		   [list $ffile]\
		   [list -back $glob(async)]
	       
          # Try { cd $dir; eval eval exec \
	  # 	    [format $config(cmd,archive) \
	  # 		 [Esc $ffile] \
	  # 		 $topwd  [Esc $ffile] ] }\
	  #     "" 1 $glob(async)
        }
      }
      default CantDoThat
    }
  }
}

proc CmdPrint {} {
  global glob
  CmdPrint_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdPrint_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdPrint_ { listb_name filelist_var frompwd topwd } {
  global config glob
  upvar $filelist_var filelist
  set inst $glob(select_cur_lr)

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Print"]]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    switch $swt {
      wl  -
      l   -
      n   {
	Log [_ "Printing %s" $ffile]
        frECF [list exec {*}[subst {*}$::stOps $config(cmd,print)]]\
	    [list $ffile]\
	    [list -back $glob(async)]
	     
            # Try {eval eval exec [format $config(cmd,print) [Esc $ffile]] } "" 1 }
      ld  -
      wld -
      d   { PopError [_ "Can't print directories!!"] }
      default CantDoThat
    }
  }
}

proc CmdMakeDir {} {
  global config glob
  if { [info exists glob(whichdir)] } {
    set newdir [$glob(win,$glob(whichdir)).entry_dir get]
  } else {
    set newdir [simple_smart_dialog "." [_ "Directory name?"] \
		    [_ "Please enter the name of the new directory.\
                        Another way of creating directories is to enter\
                        the name the new directory in one\
                        of the directory entries and then pressing the\
                        MkDir button"] $glob(left,pwd)]
    if {$newdir == ""} return
  }
  Log [_ "Creating directory %s" $newdir]
  set r [regexp {ftp://([^/]*)(.*)} $newdir match ftpI dir]
  if {$r} {
    Try { FTP_MkDir $ftpI "$dir" } "" 1
    set glob(forceupdate) 1
  } else {
    Try { file mkdir $newdir } "" 1
  }
  UpdateWindow both
  set glob(forceupdate) 0
}

proc CmdSelect {} {
  global glob
  if { [info exists glob(whichdir)] } {
    set pat [$glob(win,$glob(whichdir)).entry_dir get]
    set inst $glob(whichdir)
  } else {
    PopInfo [_ "Please enter a selection pattern in one of the\
                directory entries and then press the Select button"]
    return
  }
  $glob(win,$inst).entry_dir delete 0 end
  $glob(win,$inst).entry_dir insert end $glob(${inst},pwd)
  set pat [file tail $pat]
  set i 0
  foreach elem $glob($inst,filelist) {
    if {[string match $pat [lindex $elem 1]]} {
      $glob(listbox,$inst).file selection set $i
    }
    incr i
  }
  propagateSelection $glob(listbox,$inst).file
  UpdateStat
}

proc CmdCSelect {} {
  global glob
  set cmd [simple_smart_dialog "." [_ "Contents-select"] \
	       [_ "Make sure you have selected the files you want to\
                   search in, then please edit this command to do a\
                   contents-select."] "grep -i "]
  if { $cmd == "" } return
  CmdCSelect_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) $cmd
  CmdCSelect_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) $cmd
  UpdateStat
}

proc CmdCSelect_ { listb_name filelist_var frompwd topwd cmd } {
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      l   -
      wl  -
      n   { 
            set r [catch { eval exec $cmd {$frompwd/[lindex $elem 1]} } outp]
            if { $r != 0 } {
              $listb_name selection clear $sel
            }
          }
      default CantDoThat
    }
  }
}

# This searches the run list for 'what'
# and returns either -1 (not found) or a list
# of indexes to the found entry
proc runCmdListSearch {clist  what} {
  set level -1
  foreach en $clist {
    incr level
    if {[llength $en] != 2} {
      if {[lindex $en 0 0] == $what} {
	return $level
      }
    } else {
      set rt [runCmdListSearch [lindex $en 1] $what]
      if {$rt != -1} {
	return [concat $level 1 $rt]
      }
    }
  }
  return -1
}

proc CmdRunCmd {args} {
  frputs "Run command called to run $args "
  global glob config
  set glob(runGlob,run) {}
  set thisone {}
  # Old call sequence had 0/1 followed by name...
  foreach thisone $args {
    if {[string is integer $thisone]} {
      set thisone {}
      continue
    }
    break
  }
  if {$thisone != {} } {
    # This search is complicated by the tree structure of the runlist.
    set indx [runCmdListSearch $config(runlist) $thisone]
    if {$indx == -1} {
      PopError [_ "Run command: could not find \"%s\" in the runlist." $thisone]
      return
    }
    set glob(runGlob,run) [lindex $config(runlist) {*}$indx]
    after idle [list DoProtCmd CmdRunCmd_]
    return
  }
  # none of that, put up a menu and bail...
  
  # This is an convential menu window on which we force a tearoff.
  # This allows us to have checkboxes that don't unpost the menu.
  # Given that FixTearoff fixes most of the problems with
  # tearoff windows, all we are left with is positioning it
  # somewhere near the mouse pointer.

  # Read Config will eliminate the menu so that we can rebuild
  # it with a possibly new runlist. Otherwise, we keep the same
  # menu for the duration.

  # Unlike other tearoffs we only allow one on the screen at a time.

  set w [expr {[info exists glob(runMenu)] ? $glob(runMenu) : {}}]
  if {![winfo exists $w]} {
    # We need to build a new menu
    set w .menu_[incr glob(toplevelidx)]
    set glob(runMenu) $w
   
    destroy $w
    
    menu $w\
	-tearoff 1 \
	-title "Run menu"\
	-borderwidth 1 \
	-relief solid \
	-tearoffcommand "FixTearoff GrabTearoff"
    
    $w add checkbutton\
	-label [_ "<Edit entry>"] \
	-variable glob(runEdit)
    
    $w add checkbutton \
	-label [_ "<Delete menu on select>"] \
	-variable glob(runDeleteMenu)
 
    $w add separator
    
     buildRunListMenu
  }
  # this covers the case where it was but s/he destroyed it
  set glob(runDeleteMenu) 1
  set glob(runEdit) 0
  if {![info exists glob(runMenuTearoff)] || \
	  ![winfo exists $glob(runMenuTearoff)]} {
    $w invoke 0
  }

  if {[llength $config(runlist)] == 0} {
    set glob(runEdit) 0
    wm with $glob(runMenuTearoff)
    cmdrunEdit $glob(runGlob,run)
    return
  }
  # Now we have a menu which is in a tearoff frame
  # Lets put it near the mouse...
    
  set hm [winfo reqheight $w]
  lassign [winfo pointerxy .] msx msy
  
  # If the mouse is in the lower half of the screen, put the bottom of the
  # window where the mouse is, otherwise, put the top there
  
  set yloc [expr {$msy < [winfo screenheight .] / 2 ? $msy : $msy - $hm}]
  
  update
  # we should have a new tearoff window 
  # Lets get its true name...
  if {[info exists glob(runMenuTearoff)]} {
    set wto $glob(runMenuTearoff)
  } else {
    error "Can not find tearoff window from $w"
  }
  # wm with $w
  wm geo $wto +${msx}+$yloc
  wm deicon $wto

  frputs "Run menu building  " w wm hm ww wh "[wm geo $w] [wm geo $w]  "
  return
}

# This code snipit adds the runlist entries to the menu after first
# deleting what is there...

proc buildRunListMenu {} {
  global config glob
  set w $glob(runMenu)
  $w delete 4 end
  
  buildCasMenu {} \
      [runListMenuBuild $config(runlist)] \
      $w \
      runListButton\
      [list -tearoffcommand FixTearoff ]
  
  $w add command \
      -label [_ "<Add a new program>"] \
      -command  "runListButton 1"
}



# We pass this proc to FixTearoff which will add the two parms, the
# origional window and the name of the new tearoff.  We need the
# ladder to fix a few things...

proc GrabTearoff {menu tearoff} {
  set ::glob(runMenuTearoff) $tearoff
}

# The following is driven by glob(runGlob,run) as to what and how
# to run the program

proc CmdRunCmd_ {} {
  global glob config
  # default the pwd to left (changes if selection made in right)
  set frompwd $glob(left,pwd)
  set fl {}
  foreach inst {left right} {
    foreach sel [$glob(listbox,$inst).file curselection] {
      set elem [lindex $glob($inst,filelist) $sel]
      switch [lindex $elem 2] {
	wl  {
	  lappend fl [TranslateLnk [wLinkName $inst $elem] \
			  [lindex $glob($inst,df) 1]]
	}
	d   -
	ld  -
	l   -
	n   { lappend fl [lindex $elem 1] }
	default CantDoThat
      }
      set frompwd $glob($inst,pwd)
    }
  }
  set options [lassign $glob(runGlob,run) namecmd sep] 
  lassign $namecmd name cmd
  # set cmd [list {*}[subst {*}$::stOps $cmd]]
  if {"last+current" in $options && $glob(select_pry_lr) != {} } {
    set secdir $glob($glob(select_pry_lr),pwd)
    if { $secdir == $frompwd } {
      set secdir ""
    }
    foreach sel $glob(select_pry_s) {
      lappend fl [file join ${secdir} \
		      [lindex $glob($glob(select_pry_lr),filelist) $sel 1]]
    }
  }
  # set cmd [FixFormatString $cmd]
  # puts "run $cmd sep = $sep"
  if {"fullname" in $options} {
    set fll $fl
    set fl {}
    foreach file $fll {
      # if we already have a full name, join will just pass the file
      lappend fl [file join $frompwd $file]
    }
  }
  # we want to use frECF here.
  # This fixes the run string to accept more than one file at the same loc
  # and, with the change to -default, takes care the the file seperator issue
  # We replace the first spec (one of:%s|%n|%m|%q|%r) with that %b

  # First count the specs, keep location of the last one.
  set start 0
  set count 0
  set here [string length $cmd]
  while {[set loc [string first "%" $cmd $start]] != -1} {
    if {[string index $cmd $loc-1] == {\\}} {
      set start [incr loc]
      continue
    }
    set start [incr loc 2]
    if {[string index $cmd $loc-1] in {s n q r} } {
      incr count
      set here $loc
    }
  }
  
  set ncmd [string range $cmd 0 $here-1]
  set spec %[expr {$count > 0 ? [string index $cmd $here-1] : "s"}]
  if {[set remains [expr [llength $fl] - $count]] > 0} {
    if {$count == 0} {
      append ncmd " $spec"
      incr remains -1
    }
    append ncmd [string repeat "${sep}$spec" $remains]
    append ncmd [string range $cmd $here end]
    set cmd $ncmd
  }
  set async [expr {"async" in $options}]
  if {!$async} {
    set op [list -post \
		[list postOptions [list ViewString [_ "Output from %s %s"\
							$name \
							[string index $cmd end]]]\
		     nop]]
  } else {
    set op "-nop"
  }
  LogSilent [_ "Running command: %s" $cmd]
  cd $frompwd
  frECF [list exec {*}[subst {*}$::stOps $cmd] {*}[expr {$async ? "&" : {}}]]\
      $fl \
      [list -default "${sep}$spec" -back $async]\
      $op
  
  UpdateWindow both
}


proc runListMenuBuild {list} {
  set runMenu {}
  while {[llength $list] > 0} {
    set list [lassign $list this]
    set more [lassign $this name ent]
    if {[string index $name 0] != "-"} {
      # simple entry
      lappend runMenu [list [lindex $name 0]]
    } else {
      # a sub list
      lappend runMenu [list $name [runListMenuBuild $ent]]
    }
  }
  frputs "Raw run menu  " runMenu
  return $runMenu		       
}

# [list {label} {runstring} {{ }} fullname async]
proc cmdrunEdit {what} {
  global glob config
  set opts [lassign $what namecmd glob(runGlob,file)]
  lassign $namecmd glob(runGlob,display) glob(runGlob,run)
  set oldDisplayName $glob(runGlob,display)
  
  set glob(runGlob,full) [expr {"fullname" in $opts}]
  set glob(async) [expr {"async" in $opts}]
  set glob(runGlob,duo) [expr {"last+current" in $opts}]
  # default to add to run list 
  set glob(runGlob,add) [expr {! $glob(runEdit) ? 1 : 0}]
  set glob(runNow) 0
					 
  set sdr [smart_dialog .run \
	       . \
	       [_ "Run Dialog"] \
	       [list [_ "Edit the 'command  & ops' line.\
                         \n      Ctrl-A takes you to the start of the line.\
                         \n      Tab does command complete.\
                         \n      Mouse button 3 brings up a browser.\
                         \n      This command is run through the FileRunner\
                                  Exec Call Formater (FRECF)\
                         \n      so all format commands\
                                  that FRECF supports are available.\
                         \n      See Help menu->Tips: 'Configure options for commands II'\
                         \n      A '%s' in this string will be appended with\
                         \n      sufficient copys for the given file list\
                         \n      with the requested file seperator between them\
                         \n\n'file separator' specifies\
			 what string is used to separate files (should there\
                         \n      be more than one). Default is space ({ }).\
                         \n'display name' if supplied will be the name displayed\
                         in the run list\
                         \n'full file names' will pass the full name rather than\
                         the working directory relative name.\
                         \n'Last + current' will pass both the last selection\
                          and the current selection.\
                         \nAn edit operation, unless canceled, will save the\
                         result.\
                         \n\"Add to run list\" will, in this case, also add the\
                         same entry to the end of the list.\
                         \n" "%s, %n, %q or %r" ]] \
	       0 \
	       [expr {$glob(runEdit) ? 11 : 10}] \
	       [list [list [_ "command & opts"] \
			  "-textvariable glob(runGlob,run) -width 80"] \
		    [list [_ "file separator"] \
			 "-textvariable glob(runGlob,file)"]\
		    [list [_ "display name"] \
			 "-textvariable glob(runGlob,display)"] \
		    [list [_ "Async"] "-variable glob(async)"]\
		    [list [_ "full file\nnames"] \
			 "-variable glob(runGlob,full)"]\
		    [list [_ "Last +\ncurrent"] \
			 "-variable glob(runGlob,duo)"]\
		    [list [_ "Add to\nrun list"] \
			 "-variable glob(runGlob,add)"]\
		    [list [_ "Run \nnow?"] \
			 "-variable glob(runNow)"]\
		    [list [_ "OK"]] \
		    [list [_ "Cancel"]]\
		    [list [_ "Delete from\nrun list"]]\
		    ]\
	       [list -height 16 scroll 15 \
		    bind [list .run.0 <Tab> \
			      "Complete .run.0\
                               .run.text ; break"]\
		    bind [list .run.0 <3> \
			      "CompleteWithBrowse .run.0"]\
		   ]]
  if {$sdr == 9 || $sdr == -1 || $glob(runGlob,run) == "" } {
    return {}
  }

  if {$sdr == 10} {
    # This is the delete option...
    set config(runlist) [ldelete $config(runlist) $glob(runIndex)]
    buildRunListMenu
    return
  }

  if {$glob(runGlob,file) == {}} {
    set glob(runGlob,file) " "
  }
  if {$glob(runGlob,display) == {}} {
    set glob(runGlob,display) [lindex $glob(runGlob,run) 0]
  }
  set new {}
  if {$glob(runGlob,full)} {lappend new "fullname"}
  if {$glob(async)}        {lappend new "async"}
  if {$glob(runGlob,duo)}  {lappend new "last+current"}
  set new [list [list $glob(runGlob,display) $glob(runGlob,run)] \
	       $glob(runGlob,file) {*}$new]
  if {$glob(runEdit)} {
    lset config(runlist) {*}$glob(runIndex) $new
  }
  if {$glob(runGlob,add)} {
    # $glob(runMenu) insert [$glob(runMenu) index end] command \
    # 	-label $glob(runGlob,display)\
    # 	-command [list runListButton 2 {} [llength $config(runlist)]]
    lappend config(runlist) $new
  }
  if {$glob(runGlob,add) || $glob(runEdit) >= 0} {
    buildRunListMenu
    SaveConfig
  }
  set glob(runGlob,run) $new
  if {$glob(runNow)} {
    DoProtCmd CmdRunCmd_
  }
  return
}

# The run menu sends us here. The parms are:
#
# val this will be 1 if s/he wants to add to the run list
#                  2 if loc is the index into the runlist
#                    of the program to run
# indx is the display name (we don't use this here)
# val is a list of indexies as per 2 above

# In aaddition we use glob(runEdit) and glob(runDeleteMenu)

proc runListButton {val {indx {0}} {loc {}}} {
  global glob config
  if {$glob(runDeleteMenu) && [winfo exists $glob(runMenuTearoff)]} {
    wm with $glob(runMenuTearoff)
  }
  if {$val < 1} {
    return
  }
  if {$val == 1} {
    set glob(runEdit) 0
    if {[cmdrunEdit {}] == {}} {
      return
    }
  }
  set glob(runGlob,run) [lindex $config(runlist) {*}$loc]
  if {$glob(runEdit) } {
    set glob(runIndex) $loc
    cmdrunEdit $glob(runGlob,run)
    return
  }
  DoProtCmd CmdRunCmd_
  return
}

proc CmdForEach {} {
  global glob
  CmdForEach_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) 
  CmdForEach_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) 
}

proc CmdForEach_ { listb_name filelist_var frompwd topwd } {
  global glob config
  upvar $filelist_var filelist
  set inst $glob(select_cur_lr)

  set fl {}
  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      wl {
	lappend fl [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      d   -
      ld  -
      l   -
      n   { lappend fl [lindex $elem 1] }
      default CantDoThat
    }
  }
  if { $fl == "" } return
  if {$glob(async)} {
    PopError [_ "This command does not support asynchronous execution"]
    return
  }
  if {![info exists glob(foreach,cmd)] || $glob(foreach,cmd) == {}} {
    set glob(foreach,cmd) {echo '%s'}
  }
  set glob(foreach,cmd) \
      [simple_smart_dialog "." [_ "Foreach"] \
	   [_ "Enter command to run on each of the selected files.\
               The file will show up in the '%s'. A second '%s'\
               (if coded) will be replaced by the opposite panel's\
               working directory. You can use '%s' for the first\
               '%s' to reorder these two. You can use pipes\
               and other bourne-shell syntax elements since the\
               commands will each run in a separate bourne shell\
               in the working directory of the selected file." %s %s %2@s %s]\
	   $glob(foreach,cmd) ]
  if { $glob(foreach,cmd) == "" } return

  set output {}
  foreach k $fl {
    if {[CheckAbort [_ "ForEach"]]} return
    set pcount [expr {[stringCount {%} $glob(foreach,cmd)] - \
			  (2 * [stringCount {%%} $glob(foreach,cmd)])}]
    set k [list $k]
    if {$pcount > 1} {
      lappend k $topwd
    }
    Log [_ "Running %s ..." [list exec [subst {*}$::stOps $glob(foreach,cmd)] $k]]
    
    set rr [frECF [list exec {*}[subst {*}$::stOps $glob(foreach,cmd)]] $k]

    
    # 	   set cmd [format [FixFormatString [list $glob(foreach,cmd)]] $k]

    # 	   [FixFileNameO $k 2 {\[ $}] $topwd]
    # #append output "\$ $cmd\n"
    #  catch { 
    #   cd $frompwd 
    #   uplevel 0 [ReSpaceString "exec $config(cmd,sh)"  $cmd] 
			      # } out
			      
    append output [lindex $rr 1]
    append output "\n"
  }
  ViewString [_ "Output from commands"] output ""
  UpdateWindow both
}

proc CmdRecurseCommand { inst } {
  global glob config

  set dir $glob($inst,pwd)

  if { [IsFTP $dir] } {
    CantDoThat
    return
  }
  CmdFind $inst ok
  return
}

proc CmdDiff {} {
  global glob
  CmdDiff_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left

  CmdDiff_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right
}

proc CmdDiff_ { listb_name filelist_var frompwd topwd inst } {
    global glob
    upvar $filelist_var filelist
    global config

    set null 1
    set file1 ""
    set file2 ""
    foreach sel [$listb_name curselection] {
      set null 0
      set elem [lindex $filelist $sel]
      set swt [lindex $elem 2]
      switch -glob $swt {
	wl* {
	  set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
	}
	default {set ffile $frompwd/[lindex $elem 1]}
      }
      switch $swt {
	ld  -
	d   -
	l   -
	n   { 
	  if {$file1 == ""} { 
	    set file1 $ffile 
	  } else {
	    if { $file2 != "" } { 
	      PopError [_ "Please select one or two\
                                    files or directories for diffing."]
	      return
	    }
	    set file2 $ffile 
	    # But which was first?
	    if {$inst == $glob(select_pry_lr) && 
		$sel == $glob(select_pry_s)} { } else {
		  set tmp $file1
		  set file1 $file2
		  set file2 $tmp
		    }
		}
	    }
	default {
	  CantDoThat
	  return
	}
      }
    }

    if {$null} return

  if {$file2 == "" && $glob(select_pry_lr) != {}} {
    set sel $glob(select_pry_s)
    if {[llength $sel] == 1} {
      set elem2 [lindex $glob($glob(select_pry_lr),filelist) $sel]
      set file2  $glob($glob(select_pry_lr),pwd)/[lindex $elem2 1]
      if {[IsFTP $glob($glob(select_pry_lr),pwd)]} {
	CantDoThat
	return
      }
      switch -glob [lindex $elem 2] {
	wl* {
	  set file2 [TranslateLnk [wLinkName $glob(select_pry_lr) $elem] \
			 [lindex $glob($inst,df) 1]]
	}
      }
    } else {
	  PopError [_ "Please select one or two\
                         files or directories for diffing."]
	  return
	}
    }     
  if {! ($file2 == "")} {
    set tmp $file1
    set file1 $file2
    set file2 $tmp
  }
  frECF [list exec {*}[subst {*}$::stOps $config(cmd,diff)]] [list $file1 $file2] \
	[list -post \
	     [list postOptions \
		  [list ViewString [_ "Diffing %s and %s %s" \
					$file1 $file2\
					[string index $config(cmd,diff) end]]]\
		  [list PopInfo \
		       [_ "No difference between\n\n%s\n\nand\n\n%s" $file1 $file2]]]]\
	[list -error {}]
  
  
}

proc CmdCreateEmptyFile { inst } {
  global glob config
  set start_entry $glob($inst,pwd)
  set newfile [simple_smart_dialog "." [_ "Create New File"] \
		   [_ "Please enter the name of the new file."] \
		   $start_entry ]

  if {$newfile != ""} {
    Log [_ "Creating new file %s" $newfile]
    if {$config(cmd,touch) == {}} {
      if {![DoWeHavePackage fileutil touch]} {return}
      Try {::fileutil::touch "$newfile"} "" 1
    } else {
      Try { exec $config(cmd,touch) "$newfile" } "" 1
    }
    UpdateWindow both
  }
}

proc DeleteFTPRecursive { dir inst } {
  global glob config
  set r [regexp {ftp://([^/]*)(.*)} $dir match ftpI directory]
  Log [_ "FTP recursive delete: Entering %s" $dir]
  NewPwd $inst $dir
  UpdateWindow $inst
  foreach elem $glob($inst,filelist) {
    switch [lindex $elem 2] {
      fn  -
      fld -
      fl  {
        Log [_ "Deleting %s" $dir/[lindex $elem 1]]
        FTP_Delete $ftpI "$directory/[lindex $elem 1]"
      }
	fd { 
	    
	  if { [lindex $elem 1] != "." } {
	      if { [lindex $elem 1] != ".." } {
		  DeleteFTPRecursive "$dir/[lindex $elem 1]" $inst
	      }
	  }
      }
      default {
        error [_ "Unexpected file type in FTP recursive delete"]
      }
    }
  }
  Log [_ "Deleting %s" $dir]
  NewPwd $inst "$dir/.."
  UpdateWindow $inst
  FTP_RmDir $ftpI "$directory"
}

proc CopyFromFTPRecursive { fromdir todir inst resume } {
  global glob config
  if {[CheckAbort [_ "CopyFromFTPRecursive"]]} return
  set r [regexp {ftp://([^/]*)(.*)} $fromdir match ftpI directory]
  set dir [file tail $directory]
  Log [_ "FTP recursive copy: Creating %s" $todir/$dir]
  file mkdir "$todir/$dir"
  Log [_ "FTP recursive copy: Entering %s" $fromdir]
  NewPwd $inst $fromdir
  UpdateWindow $inst
  foreach elem $glob($inst,filelist) {
    if {[CheckAbort [_ "CopyFromFTPRecursive"]]} return
    switch [lindex $elem 2] {
      fld -
      fl {
        Log [_ "Skipping %s - link" $fromdir/[lindex $elem 1]]
      }
      fd {
	  if { [lindex $elem 1] != "." } {
	      if { [lindex $elem 1] != ".." } {
		  CopyFromFTPRecursive "$fromdir/[lindex $elem 1]" \
		      "$todir/$dir" $inst $resume
	      }
	  }
      }
      fn {
        Log [_ "FTP recursive copy: Copying %s -> %s bytes)" \
             $fromdir/[lindex $elem 1] \
             "$todir/$dir/[lindex $elem 1] ([lindex $elem 3]"]
        FTP_GetFile $ftpI "$directory/[lindex $elem 1]" \
	    "$todir/$dir/[lindex $elem 1]" "[lindex $elem 3]" $resume
      }
      default {
        error [_ "Unexpected file type in FTP recursive copy"]
      }
    }
  }
}

proc CopyToFTPRecursive { fromdir todir inst } {
  global glob config
  if {[CheckAbort [_ "CopyToFTPRecursive"]]} return
  set r [regexp {ftp://([^/]*)(.*)} $todir match ftpI directory]
  set dir [file tail $fromdir]
  Log [_ "FTP recursive copy: Creating %s" $todir/$dir]
  FTP_MkDir $ftpI "$directory/$dir"
  Log [_ "FTP recursive copy: Entering %s" $fromdir]
  NewPwd $inst $fromdir
  UpdateWindow $inst
  foreach elem $glob($inst,filelist) {
    if {[CheckAbort [_ "CopyToFTPRecursive"]]} return
    switch [lindex $elem 2] {
      ld -
      l {
        Log [_ "Skipping %s - link" $fromdir/[lindex $elem 1]]
      }
      d {
 	  if { [lindex $elem 1] != "." } {
	      if { [lindex $elem 1] != ".." } {
		  CopyToFTPRecursive "$fromdir/[lindex $elem 1]" \
		      "$todir/$dir" $inst
	      }
	  }
      }
      n {
        Log [_ "FTP recursive copy: Copying %s -> %s bytes)"\
		 $fromdir/[lindex $elem 1] \
		 "$todir/$dir/[lindex $elem 1] ([lindex $elem 3]"]
        FTP_PutFile $ftpI "$fromdir/[lindex $elem 1]" \
	    "$directory/$dir/[lindex $elem 1]" "[lindex $elem 3]"
      }
      default {
        error [_ "Unexpected file type in FTP recursive copy"]
      }
    }
  }
}

proc FindDialog {inst pat} {
  # we use a special version of viewstring where we provide the call 
  # to the string search...
  #set result [join [lsort $result] "\n"]
  set result ""
  return [ViewString \
	      [_ "Find %s in %s Click on file to display in panel" \
		   $pat "[pwd]/*" ] \
	      result $inst FindConfig]
}
proc FindConfig {w title inst result} {
  global glob
  upvar 2 $result string
  centerWin $w
  textSearch $w.text $title  "+buildViewConfig" \
      {} \
      [list \
	   {Sort on tail} "findSort $w.text t" \
	   {Sort on full name} "findSort $w.text f" \
	   {Save As...} "SaveToFile $w.text [Esc $glob($inst,pwd)/] 1" \
	   [_ Quit]  "destroy $w"]
  bind $w.text <1> "GotoFind \"$glob($inst,pwd)\" \"\[findGetLine  $w.text %x %y]\" $inst;break"
  #puts "$string"
}

proc findGetLine {w x y} {
  lassign [split [$w index @$x,$y] .] line
  return [$w get $line.0 $line.end]
}
proc findSort {w opt} {
  set files [split [$w get 0.0 end] \n]
  $w delete 0.0 end
  $w mark set insert 0.0
  set sort {}
  foreach file $files {
    if {$file != {} } {
      if {$opt == "t"} {
	lappend sort [file tail $file]$file
      } else {
	lappend sort $file
      }
    }
  }
  #puts "$sort"
  set sindex [lsort -indices $sort]
  foreach idx $sindex {
    $w insert insert "[lindex $files $idx]\n"
  }
}

proc GotoFind { dir file inst } {
  global glob
  frputs "gfind [pwd]  " inst dir file
  if {[string index $file 0] == " "|| $file == {}} {return}
  set file [file norm [file join $dir $file]]
  NewPwd $inst [file dirname $file]
  UpdateWindow $inst
  set j 0
  set name [file tail $file]
  if {$name == {}} {return}
  foreach i $glob($inst,filelist) {
    if {[lindex $i 1] == $name} {
      $glob(listbox,$inst).file selection clear 0 end
      $glob(listbox,$inst).file selection set $j
      $glob(listbox,$inst).file see $j
      propagateSelection $glob(listbox,$inst).file
      return
    }
    incr j
  }
  PopError [_ "File %s/%s can not be found" $file]
}

# fileutilFindAsyncHandler is an async function to set up a call to
# ::fileutil::find. It will provide a compare function based on the
# cmds and will log results to 'logFun'
#
proc fileutilFindAsyncHandler {w cmds logFun} {
  # first remove the >2 stuff
  if {[lindex $cmds end-1] == ">2"} {set cmds [lreplace $cmds end-1 end]}
  set ::findStop$w 0
  set parms  [lindex $logFun 1 ]
  frputs "fileutilFindAsync  " 
  set r [catch {::realfind::realFind [list [pwd]] \
    "$cmds" [linsert $logFun end "::findStop$w" "data"]} what]
  if {$r !=0} {
    #puts "rtn $what"
    findData $parms $w d data " ${what}\n"
    findData $parms $w d data " $::errorInfo"
  } else {
    #puts "rtn 0 $what"
    foreach line $what {
      findData $parms $w d data " $line"
    }
  }
  findData $parms $w d eof
  unset ::findStop$w
  
}

proc CmdFind { inst {ext -1}} {
  global glob config
  set ftp [IsFTP $glob($inst,pwd)]
  catch "destroy .apop"
  if {![info exists glob(searchstring)]} {
    set glob(find,string) ""
    set glob(find,options) {}
    set glob(find,expressions) {}
    set glob(find,regexp) 0
    set glob(find,casefold) 0
  }
  if {$ext != -1 && ![info exists glob(foreach,all)]} {
    set glob(foreach,all) 0
    set glob(foreach,cmd) {}
  }
  set smart_buts \
      [list \
	   [list [_ "name or regex pattern"] {-textvariable glob(find,string)}]\
	   [list [_ "extra options (-L,-P,-D,-O)"] {-textvariable glob(find,options)}]\
	   [list [_ "extra expressions and tests"] {-textvariable glob(find,expressions)}]\
	   [list [_ "regexp"] {-variable glob(find,regexp)}]\
	   [list [_ "casefold"] {-variable glob(find,casefold)}]\
	   [list {} [list -text [_ "\nEnter <command> to run on each file\
                     or all files as a group\
                     (option <all files>). The file(s) will show up in the '%s'\
                      (or at the end of the command if %s is not coded).\ 
                     \nThe commands are run directly by the tcl exec command.\
                     You can use pipes and other tcl exec constructs.\
                     You can also enter a shell as the first part of the\
                     command to pickup shell syntax elements."  \
				     "%s" "%s" ] \
			 -wraplength [expr {60 * [font measure $config(gui,ListBoxFont) {0}]}]\
			 -justify left]\
		]\
	   [list {} {-textvariable glob(foreach,cmd)}]\
	   [list [_ "all files"] {-variable glob(foreach,all)}]\
	   [_ OK] [_ Cancel]]

  if {$ftp} {
    set smart_buts [lreplace $smart_buts 1 4]
  }
  if {$ext == -1} {
    set title [_ "Find..."]
    set startMes [list {} [_ "Please enter substring of filename\
                        to search for in %s and below." $glob($inst,pwd)]]
    set smart_buts [lreplace $smart_buts end-4 end-2]
  } else {
    set title [_ "Run Command Recursively"]
    set startMes [list [_ "This command will run:\
                 \n\n find %s <options>\
                 \n\n(with <options> selected below) to\
                 recurse into the current directory (%s).\
                 \nThe below entered <command> will then be run on all files\
                 from this find (either singly or as a group).\n\
                 \nSee also: manpage for the find command.\
                 \n\nUse tab to go to next entry.\
                 Return or the OK button starts execution."\
			    $glob($inst,pwd) $glob($inst,pwd)]]
  }
  set butCount [llength $smart_buts]

  set r [smart_dialog ".dbl_entry_dialog" "."  [_ "Find..."]\
	     $startMes \
	     -1 $butCount\
	     $smart_buts [buildDialogConfig] \
	     [list bind [list .dbl_entry_dialog.1 <Return> \
			     "event generate .dbl_entry_dialog.0 <Tab>"]]]

  if {$r == -1 || $r == ($butCount - 1)} {return}

  #----------------------------------- ftp code -------------------------
  if {$ftp} {
    if {$glob(find,string) == {}} {return}
    set r [catch {FTP_CD $ftpI $directory} out]
    if {$r != 0} {
      PopError $out
      return
    }
    LogStatusOnly [_ "Searching, please wait..."]
    set r [catch {FTP_DispatchDoSearch $ftpI $glob(find,string)} out]
    LogStatusOnly [_ "Searching, please wait...done"]
    if {$r} {
      PopError [_ "FTP search error: %s" $out]
      return
    }
    ViewString [_ "FTP search results"] out ""
    return
  }
  #----------------------------------------end of ftp code ------------------
  set r [catch {cd $glob($inst,pwd)} out]
  if {$r} {
    PopError "$out"
    return
  }
  if {$ext != -1} {
    set ext [list $glob(foreach,all) $glob(foreach,cmd)]
  }
  if {$glob(find,expressions) == {} && $glob(find,string) == {}} {return}
  set pcall {}
  if {$glob(find,string) != {}} {
    # build the proper pattern call out name, iname regex iregex
    switch -exact $glob(find,regexp)$glob(find,casefold) {
      00 {set pcall "-name"}
      01 {set pcall "-iname"}
      10 {set pcall "-regex"}
      11 {set pcall "-iregex"}
    }
  }
  set pat {}
  if {$glob(find,string) != {}} {
    if {$glob(find,regexp)} {
      set pat  .*$glob(find,string).* 
    } else {
      set pat  *$glob(find,string)*
    }
  }
  # Use the frECF to get this right...
  set cmds [slList {*}[subst {*}$::stOps $config(cmd,find)] \
		{*}$glob(find,options) [pwd] $pcall %n \
      		{*}$glob(find,expressions) -print 2> /dev/null]
  set cmds [frECF $cmds [list  $pat] -f 1]
  frputs "parts of find  " cmds glob(find,string) pat
  set w [FindDialog $inst "$pat $glob(find,expressions)"]
  set logFun [list findlog [list findData [list [list $ext [pwd]]] $w]]
  if {$config(cmd,find) == {}} {
    set cmds [slList {*}$glob(find,options) $pcall \
		  $pat {*}$glob(find,expressions)]
		  
    set geo [buildStop $w \
		 [_ "Searching, %s for %s. Please wait..." "[pwd]/*" "$pat" ] \
		 "set ::findStop$w" 1]
    after idle [list fileutilFindAsyncHandler $w "$cmds" \
		    [list findData [list $ext [pwd]] $w]]
  } else {
    # We have a race here as 'buildStop' needs to do an update which
    # means that calling after we call pipeoExec allows the pipo command
    # to send us stuff before we are ready.  So,
    # Here we set a dummy call back to 'update' which should never be
    # called and then after the pipeo call we update the call back
    # function to what it ougth tobe (for which we need the fid that
    # pipeo returns.
    set geo [buildStop $w \
		 [_ "Searching, %s for %s. Please wait..." "[pwd]/*" "$pat" ] \
		 update 1]
    lassign [pipeoExec $cmds r $logFun] r fid
    if {$r != 0} {
      destroy $w
      error "Bad find call: $fid \n $cmds"
    }
    stopReSetCallBack $w "pipeoAbort $fid"
  }
  if {[winfo exists $w]} {wm geo $w $geo}
}

proc findData {parms w fid tag {arg {}}} {
  lassign $parms ext pwd
  frputs "[incr ::xx] $ext $fid $tag $arg " pwd
  set loc [$w.text index end-1chars]
  lassign [split $loc .] line char
  frputs "findData  " parms arg
  if {$tag == "data" } {
    if {$ext == "com"} {
      $w.text insert insert ${arg}
    } else {
      if {[string index $arg end] != "\n" } {
	StopProgress $w $arg
      } else {
	if {[string compare -length [string length $pwd] $pwd ${arg}] == 0} {
	  $w.text insert insert  [string range ${arg} [string length $pwd]+1 end]
	} else {
	  $w.text insert insert ${arg}
	}
      }
      $w.text see insert
    }
    return
  }
  # must be end of file. If no data, kill the window and use a popup...
  LogStatusOnly [_ "...done"]
  set loc [$w.text index end-1chars]
  if {[$w.text index insert] == 1.0} {
    destroy $w
    if {$ext == "com"} {
      PopInfo [_ "No output"]
    } else {
      PopInfo [_ "No files found"]
    }
    return
  }
  # At this point we have a list of found files
  # If ext is -1 we just remove the stop button and
  # sort the files
  # Otherwise, ext will be 1 if we are to send all files
  # to the command and 0 if we are to send them one at a time
  # In either case we use pipeo an give a running result
  frputs "Phase 2?  " ext
  if {$ext == -1} {
     findSort $w.text f
  } else {
    if {[lindex $ext 0] == "com"} {
      incr ::[set w]_flag
      return
    }
    lassign $ext all cmd
    # if {[string first {%s} $cmd] == -1} {
    #   append cmd " %s"
    # }
    # get the file, remove any error lines...
    set files {}
    foreach fl [split [$w.text get 0.0 end] \n] {
      if {$fl == {} || [string index $fl 0] == " "} {continue}
      lappend files $fl
    }
    frputs "phase 2  " files
    $w.text delete 0.0 end
    set Log [list findlog [list findData [list [list com [pwd]]] $w]]
    # foreach fl $files {
    # 	lappend fll [FixFileNameO [file native $fl] 3 { }]
    # }
    foreach fl $files {
      if {$all == 1} {
	set fl $files
	# set fl [join $fll " "]
      } else {
	set fl [list $fl]
      }
      # set realCmd  "[ReSpaceString {} [format $cmd [braceToQuote $fl]]]\n"
      set realCmd [frECF [list {*}[subst {*}$::stOps $cmd]] $fl -f 1]
      set realCmd [subst -noc -nov $realCmd]
      StopProgress $w $realCmd
      frputs "To pipo $realCmd  " fl
      lassign [pipeoExec $realCmd r $Log] r fid 
      if {$r != 0} {
	destroy $w
	error "Bad find call: $fid \n $cmd"
      }
      stopReSetCallBack $w "pipeoAbort $fid"
      # wait for completion...
      vwait ::[set w]_flag
      if {$all == 1} {break}
    }
    catch "unset ::[set w]_flag" 
  }
  StopButRemove $w

}

proc findlog {fid tag} {Log "Find log: $tag"}

proc CmdChmod {} {
  global glob
  CmdChmod_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left
  CmdChmod_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right
}

proc CmdChmod_ { listb_name filelist_var frompwd topwd inst } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist
  set fl {}
  

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Chmod"]]} return
    set elem [lindex $filelist $sel]
    lassign $elem {*}$glob(fListEl)
    switch $type {
      l   -
      ld  -
      n   -
      d   {
	incr ftpFlag 0
	if {$glob(os) == "WIN32"} {
	  PopInfo [_ "So sorry, can't do chmod on windows files."]
	  return
	}
	set localMode [file attributes $frompwd/$file -permissions]
	lassign [split $usergroup /] user group
      }
      default {
	# Must be an nFTP, maybe we can do it... up to the handler and remote
	incr ftpFlag
	set localMode [GetModeFromString $mode]
	lassign [split $usergroup /] user group
	# puts "got $mode from >[lindex $elem 5]<"
      }
    }
    lappend fl  $frompwd/$file
  }
  # Note to me, we present the flags to the last file in the list
  # but apply the result to all files...
  if {$fl != ""} {
    set rarg [ChmodDialog $frompwd/$file $localMode $user $group]
    lassign $rarg arg ownarg
    if {$arg != ""} {
      if { $ftpFlag } {
	# for ftp we will use a seperate call for each file...
	foreach file $fl {
	  set r [regexp {ftp://([^/]*)(.*)} $file match ftpI fl]
	  if {$r == 0} { 
	    PopError [_ "Can't parse %s as ftp URL" $frompwd] 
	  } else {
	    set r [FTP_Chmod $ftpI $arg $fl]
	    if { $r != "0" && $r != "" } {
	      PopError $r
	      break
	    }
	  }
	}
      } else {
	# we need to do this to get the quotes right...
	frECF [list exec {*}[subst {*}$::stOps $config(cmd,chmod)] $arg]\
	    $fl\
	    [list -back $glob(async)]
	# foreach f $fl {
	#   append cmd [FixFileNameO $f 2 { \[$}]
	#   append cmd " "
	# }
	# frputs "start  " cmd
	# Try [ReSpaceString "exec $config(cmd,chmod) $arg" $cmd] 1 $glob(async)
	# # Try "exec $config(cmd,chmod) $arg [FixFileNameO {*}$fi 2 { } 1]" 1 $glob(async)
      }
      ForceUpdate $inst
    }
    if {$ownarg != ""} {
      if { $ftpFlag } {
	# for ftp we will use a seperate call for each file...
	foreach file $fl {
	  set r [regexp {ftp://([^/]*)(.*)} $file match ftpI fl]
	  if {$r == 0} { 
	    PopError [_ "Can't parse %s as ftp URL" $frompwd] 
	  } else {
	    set r [FTP_Chown $ftpI $ownarg $fl]
	    if { $r != "0" && $r != "" } {
	      PopError $r
	      break
	    }
	  }
	}
      } else {
	frECF [list exec {*}[subst {*}$::stOps $config(cmd,chown)] $ownarg]\
	    $fl\
	    [list -back $glob(async)]
	
	# foreach f $fl {
	#   append cmd [FixFileNameO $f 2 { \[$}]
	#   append cmd " "
	# }
	# # Try "exec $config(cmd,chown) $ownarg [FixFileNameO $fi 2]" "" 1 $glob(async)
 	# Try [ReSpaceString "exec $config(cmd,chown) $ownarg" $cmd] 1 $glob(async)
     }
      ForceUpdate $inst
    }
    
  }
}

proc CmdGetHttp { inst } {
  global glob config
  
  if {[IsFTP $glob($inst,pwd)]} {
    PopInfo [_ "You can only download HTTP files to a non-FTP directory"]
    return
  }

  if {![info exists glob(http,lasturl)]} {
    set glob(http,lasturl) {}
  }
  set URL $glob(http,lasturl)

  while { 1 } {
    set URL [simple_smart_dialog "." [_ "Get HTTP File"] \
		 [_ "Please enter HTTP URL to download"] $URL ]
    if {$URL == ""} {
      return
    }
    
    if {[string range $URL 0 6] != "http://" } {
      set URL "http://$URL"
    }
    
    set r [regexp {http://([^/]*)(.*)} $URL match host_and_port location]
    if {!$r} {
      PopError [_ "Could not parse %s as an HTTP URL" $URL]
      continue
    } 
    if {$location == ""} {
      append URL /
    }
    set glob(http,lasturl) $URL
    break
  }

  set filename [file tail $URL]
  if {[string range $URL end end] == "/"} {
    append filename .html
  }
  set filename [simple_smart_dialog "." [_ "Get HTTP File"] \
		    [_ "Please edit filename to save to.\n(URL: %s)" $URL] \
		    $filename]
  if {$filename == ""} {
    return
  }
  cd $glob($inst,pwd)
  HTTP_Get $URL $filename
  UpdateWindow both
}

