#!/usr/bin/env tclsh
#<20170401.1254.11>
# The soul purpose of this file is to provide a *.tcl file that will cause windows
# to run it with the program (hopefully tclsh) attached to *.tcl files
#
# we then source the real filerunner.
########################################################
#  This is the boiler plate code ver <20160420.1642.12>#                 
########################################################
# This bit of code figures out where the rest of the   #  
# routines are on the assumption that they are in the  #
# same directory as the initial code file.             #
# If 'setIt' is 1 or not coded auto_path is set in any #
# case the resulting dir is returned to the caller     #
# A second dir is also returned, which is the same     #
# with a leading C:/ removed as required by Wrap code  # 
# for windows. If not windows the two will be the same.#
#                                                      #
# To function correctly this code MUST be called prior #
# to completion of the 'source' command that brings it #
# in. Also, since it is used to set up auto_path it    #
# can not be auto loaded.  It may be sourced, but      #
# again the from where issue is there.                 #
#                                                      #
# It is best if this is just merger with the using     #
# code in a location prior to its call.                #
#                                                      #
proc cSetAutoPath {new} {
  if {$new ni $::auto_path} {lappend ::auto_path $new}
}

proc setAutoPath {{setIt 1}} {
  set it [info script]
  set it [expr {$it == "" ? "[pwd]/*" : $it}]
  set it [file dir [file dir [file norm $it/*]]]
  # Wrap code requires we not have the drive letter...
  if {$setIt} {
    cSetAutoPath $it
    cSetAutoPath [regsub {^[a-zA-Z]:/} $it {/}]
  }
  return [list $it [regsub {^[a-zA-Z]:/} $it {/}]]
}
##########################################################
#            End of boiler plate code                    #
##########################################################

# In windows (not in wrap code) we want to start in tclsh
# if we are not there, just exec fr, otherwise source it.
#
set trueFr  [lindex [setAutoPath 0] 1]/fr
set ex [info nameofex]

if {[string match -nocase {*wish*} [file tail $ex]] &&\
	$tcl_platform(platform) == {windows} &&\
	! [string match -nocase [file extension $argv0] {.exe}] &&\
	[set target [auto_execok tclsh]] != {}} {
  exec $target $trueFr {*}$argv &
  exit 0
}

set r [catch [list source $trueFr] out]

if {$r != 0} {
  puts "Sourceing $trueFr failed with error: $out"
}
# all done
