# centerWin --
#
#      Centers a window (win) in its parent (ow). 
#      Improved version of one found in Midnight Commander.
#
proc centerWin {win {ow {}}} {
  if {1} {
  #wm withdraw $win
    waitForIdle
  set top [wm attributes . -topmost]
  if {$ow == {}} { set ow [winfo parent $win] }
  foreach {c r} {y height x width} {set cen$c [winfo $r $win]}
  foreach {id r} {pdx width pdy height px rootx py rooty} {set $id [winfo $r $ow]}
  foreach c {x y} {set $c [expr \$p$c+((\$pd$c-\$cen$c)/2)]}
  wm geometry ${win} +$x+$y
  } else {
    puts "doing PlaceWindow $win widget $ow"
    ::tk::PlaceWindow $win widget $ow
  }
}
#
# centerMouse2
#
# This function moves the mouse pointer, by default to the 
# center of a given widget.
#
# parms:
#        w     The window to move the pointer to
#        wmgeo That windows geometry (WxH+x+y) (optional)
#              if not supplied [winfo geom $w] is used.
#              If that window does not exist, we just return.
#              Only the W & H numbers are used so this parm
#              may be supplied as: ${x}x${y}.  The mouse
#              will be moved to x: W/2 y: H/2, i.e centered
#              in the window or the x,y.  There is no
#              restriction that the target be in the given 
#              window, but the position is relative to that
#              window. 

# It is assumed that this will be used after positioning the window 
# and, usually with focus.  This means that there is a very real chance
# that the movement has not yet been done AND [update] in any of 
# its forms will not fix this.  The solution that seems to work is
# to use an [after] statement so we take care of that below...

# Do note that if you want to use the 'now' version, the second parm is
# required.
        

proc centerMouse2 {w {wmgeo ""}} {
  if {$wmgeo=="" && [catch "winfo geom $w" wmgeo] != 0} {return}
  after idle "centerMouse2now $w $wmgeo"
}

proc centerMouse2now {w wmgeo} { 
  lassign [split $wmgeo x+] x y;
  #puts "x $x y $y"
  event generate $w <Motion> -warp 1 -x [expr $x/2] -y [expr $y/2]
}
