# -*- tcl -*-
#
# A little function to figure relative file paths
# given 'file' and 'rel' a directory we wish to access
# a file in the same dir as 'file' useing a relative path, 
# return the prefix needed. If no prefix is needed 
# return "", otherwise a '/' preceeded by what is needed.


proc getRel {file rel} {
  # return the string to prepend to a file name to 
  # make it relative to 'rel'
  set thisDir [file dirname [file normalize $file]]/
  #puts "prefix $file-> $thisDir $rel"
  if {[string index $rel end] == "/"} {
    set rel [string range $rel 0 end-1]
  }
  if {$thisDir == $rel} {
    return {}
  }
  set indx 0
  set max [expr {max([string length $thisDir],[string length $rel])}]
  while {$indx <= $max && \
	     [string index $thisDir $indx] == [string index $rel $indx]} {
    incr indx
    #puts "i $indx $max"
  }
  while {$indx > 0 && [string index $thisDir $indx] != "/"} {incr indx -1;}
  set thisDir [string range $thisDir $indx+1 end]
  set rel [string range $rel $indx+1 end]
  if {[string length $rel] == 0} {return "$thisDir"}
  set pre "../"
  while {[string length [set rel [file dir $rel]]] > 1} {append pre "../$pre"}
  return "$pre$thisDir"

}
